#Author:wikii
#Version:0.02
#Date:20080309
#description:Creat pages for shadow research.
def shadow_pages_setting filename
  str=IO.readlines(filename)
  str.delete_if{|x| x.strip==""}
  re=Hash.new
  str.each{|x|
    x=~/\d*?\.\d*?[E|W]\s*?\d*?\.\d*?[N|S]\s*?.*/i
    re[$`]=$&
  }
  keys=re.keys[0..15]
  puts keys
  prompts = [":",":","·:",":",":"]
  tt=Time.now
  values = [keys[0],tt.year.to_s,tt.month.to_s,tt.day.to_s,"30"]
  popups = [keys.join("|")]
  results = inputbox( prompts, values, popups, "ѡ" )
  return if !results
  jwd=re[results[0]].upcase.split(" ")
  puts jwd
  case jwd[0][-1,1]
    when "E"
    jwd[0]=  jwd[0].to_f 
    when "N"
    jwd[0]=  jwd[0].to_f *-1
  end
  case jwd[1][-1,1]
    when "N"
    jwd[1]=  jwd[1].to_f 
    when "S"
    jwd[1]=  jwd[1].to_f *-1    
  end
  jwd[2]=jwd[2].to_f
  puts jwd[2]
  results[0]=jwd
  results
end
#~ ##~ puts getlocation "c:\\china.txt"
def shadow_pages
  Sketchup.active_model.shadow_info["DisplayShadows"] =true
  loc=shadow_pages_setting (File.dirname(__FILE__)+"\\china.txt")
  Sketchup.active_model.shadow_info["Longitude" ]=loc[0][0]
  Sketchup.active_model.shadow_info["Latitude" ]=loc[0][1]
  
  
  Sketchup.active_model.shadow_info["TZOffset"]=loc[0][2]
  model=Sketchup.active_model
  view=model.active_view
  camera=view.camera
  daybegintime=Time.gm( loc[1].to_i,loc[2].to_i,loc[3].to_i)
  
  Sketchup.active_model.shadow_info["ShadowTime"]=daybegintime

  start_time=Sketchup.active_model.shadow_info["SunRise"]
  end_time=Sketchup.active_model.shadow_info["SunSet"]
  
  puts start_time
  puts end_time
  m=loc[4].to_i
  1.upto(1440/m){|x|  
    time=daybegintime+x*m*60
    Sketchup.active_model.shadow_info["ShadowTime"] =time
    next if Sketchup.active_model.shadow_info["SunDirection"].z<0
    Sketchup.active_model.pages.add time.hour.to_s+":"+time.min.to_s  
  }  
end

