##Athor:wikii
##Date:20080302
##Version:v0.01
##Description:
##Usage for sutool:
##ϸ|subdivideSelected 1|subdivideSelected.rb|ͨĶĽϸ
##ϸ|subdivideSelected 2|subdivideSelected.rb|ͨıеĽϸ

require 'sketchup.rb'

def midpoint ev
   pt=ev.collect{|x| Geom::Point3d.new x.position}
   rpt=Geom::Point3d.new
   pt.each{|x| rpt=rpt+Geom::Vector3d.new(x.x, x.y, x.z)}
   Geom::Point3d.linear_combination( 10, Geom::Point3d.new(0.mm,0.mm,0.mm), 1.0/ev.size, rpt)
end

def subdivideSelected( type = 1)
   Sketchup.active_model.start_operation  "subdivideSelected"
   model = Sketchup.active_model
   e=model.entities
   e_len=e.length
   ss = model.selection
   pt_ar=[]

   if type==1#by vertex
      ss.each {|entity|
         if entity.typename == "Face"
            evs = entity.vertices
            $ev=evs
            #cen = entity.bounds.center
            cen = midpoint( evs)
            evs.each {|vt| edge = model.active_entities.add_edges cen,vt }
         end
      }
   else#by midpoint
      ss.each {|entity|
         if entity.typename == "Face"
            edges=entity.edges
            evs = entity.vertices
            #cen = entity.bounds.center
            cen = midpoint( evs)
            edges.each{|edge|
               pt_ar<<[ cen,  edge.bounds.center]
            }
         end
      }
      pt_ar.each{|x|  model.active_entities.add_edges x[0], x[1]}
   end
   Sketchup.active_model.commit_operation
   e_len.upto(e.length-1){|x|  ss.add e[x]}
   #e[e_len..-1].each{|x| ss.add x}
end # end triangulateSelected
