# This script will install itself in the /plugins/ menu as "#HideAll.rb".  
# When executed, it will hide all objects that are not in the current selection.  
# All hiding operations are grouped as a single UNDO operation. 
# It did not support being in group or component edit mode.***  
# If you have drilled into a group or component and run this script, 
# everything would hide.*** 
#
# Author: Todd Burch 
#
### TIG tweaked 15/1/6 - *** groups/components etc now work within hide ###
### to edit within a group/component first select it and hide the rest ###
### then edit it and select and hide unselected within it ###
### unhide with edit and model to undo all hides ###
require 'sketchup.rb'
class Hide
def Hide.hideAll
  model=Sketchup.active_model###
  model.start_operation "Hide Unselected"
  ents=model.active_entities### active NOT all
  ss=model.selection###
  ents.each{|e|e.hidden=true}###
  ss.each{|x|x.hidden=false}###
  model.commit_operation
end # hideAll
end # Class
if (not file_loaded?("#hideall.rb") )###
   ###UI.menu("Plugins").add_item("Hide All Unselected") { Hide.hideAll }
   UI.add_context_menu_handler do |menu|###
      menu.add_separator
      menu.add_item("隐藏所有未选中的物体"){Hide.hideAll}
   end#menu ###
end
file_loaded("#hideall.rb")###
###